<template>
  <div>
    <b-card
          border-variant="danger"
          
      >
      <b-row>
        <b-col
          cols="6"
          xl="6"
          class="d-flex justify-content-between flex-column"
        >
          <div class="d-flex flex-column ml-1">
            <div class="mb-1">
              <span class="font-weight-bold">Proyecto</span>
              <h4 class="mb-0 text-capitalize" >
                {{ projectData.name }}
              </h4>
            </div>
            <div class="mb-1">
              <span class="font-weight-bold">Descripción</span>
              <h4 class="mb-0 text-capitalize" >
                {{ projectData.description }}
              </h4>
            </div>
            <div class="mb-1">
              <span class="font-weight-bold">Cliente</span>
              <h4 v-if="projectData.user_client" class="mb-0 text-capitalize" >
                {{ projectData.user_client.name }}
              </h4>
            </div>
            <br>
            
          </div>
        </b-col>

        <b-col 
          cols="6"
          xl="6"
        >
          <span class="font-weight-bold">Encargado</span>
          <h4 v-if="projectData.user_manager" class="mb-0 text-capitalize" >
            {{ projectData.user_manager.name }} {{ projectData.user_manager.last_name }}
          </h4>
          <br>
          <b-avatar v-if="projectData.user_manager && projectData.user_manager.image"
            size="100px"
            :src="baseURL+projectData.user_manager.image"
            rounded
          />
          <b-avatar v-if="projectData.user_manager && !projectData.user_manager.image"
            size="100px"
            rounded
          />
        </b-col>


      </b-row>
      <br>
      <b-row>
        <b-col cols="12"
          xl="12"
          class="d-flex justify-content-between flex-column"
        >
          <h3>Equipo de trabajo </h3>
          <br>
          <b-table
            class="position-relative"
            :items="projectData.users"
            responsive
            :fields="tableColumns"
            primary-key="id"
            show-empty
            sticky-header
            empty-text="No se encontraron registros"
          >
            <template #cell(image)="data">
              <b-avatar
                v-if="data.item.image"
                class="mr-1" 

                size="lg"
                :src="baseURL+data.item.image"
              />
              <b-avatar
                v-else
                class="mr-1" 
                size="lg"
              />
            </template> 

        </b-table>
        </b-col>
        
      </b-row>
       <br>
       <br>
      <div class="d-flex flex-wrap">
        <b-button v-if="boolEdit && projectData.id"
         :to="{ name: 'apps-projects-edit', params: { id: projectData.id } }"
          variant="primary"
        >
          Editar
        </b-button>
        <b-button
          v-if="boolDelete"
          variant="outline-danger"
          class="ml-1"
          @click="deleteProject(projectData.id)"
        >
          Eliminar
        </b-button>
      </div>
    </b-card>
    
  </div>
</template>

<script>
import {
  BRow, BCol,BCard,BAvatar, BForm,BTable,BDropdown,BCardText, BDropdownItem, BFormGroup, BFormInput, BFormRadioGroup, BFormCheckboxGroup, BButton,
} from 'bootstrap-vue'
import { ref } from '@vue/composition-api'
import vSelect from 'vue-select'

export default {
  components: {
    BRow,BCard,BAvatar, BCol, BForm,BTable,BDropdown, BDropdownItem,BCardText, BFormGroup, BFormInput, vSelect, BFormRadioGroup, BFormCheckboxGroup, BButton,
  },
  props:{
    projectData: {
      type: Object,
      required: true,
    }
  },
  data(){
    return{
      baseURL:'http://quantumdaily-back.test/storage/',
      tableColumns:[
        { key: 'image', label: "Perfil", sortable: true },
        { key: 'name', label: "Nombre", sortable: true },
        { key: 'last_name', label: "Apellidos", sortable: true }
      ],
      boolEdit:false,
      boolDelete:false

    }
  },
  methods:{
    deleteProject(id){

       this.$swal({
        title: '¿Está seguro de eliminar el registro?',
        text: "No podrás revertir esto!",
        icon: 'warning',
        showCancelButton: true,
        confirmButtonText: 'Si, eliminar!',
        customClass: {
          confirmButton: 'btn btn-primary',
          cancelButton: 'btn btn-outline-danger ml-1',
        },
        buttonsStyling: false,

      }).then(result => {
        if (result.value) {
          let parametros = {id: id};
          this.$http.get("project/delete", { params: parametros }).then((res) => {
            if(res.data.message === 'eliminado'){
              this.$swal({
                icon: 'success',
                title: 'Eliminado!',
                text: 'El registro ha sido eliminado.',
                customClass: {
                  confirmButton: 'btn btn-success',
                },
              })
              this.$router.push({ name: 'apps-projects-list' })
            }else if(res.data.message === 'No se encontro el registro'){
              this.$swal({
                title: 'Error!',
                text: ' No se pudo eliminar!',
                icon: 'error',
                customClass: {
                  confirmButton: 'btn btn-primary',
                },
                buttonsStyling: false,
              })
            }else if(res.data.message === 'haveActivities'){
              this.$swal({
                title: 'Error!',
                text: ' Este proyecto cuenta con una o más actividades activas, no se pudo eliminar',
                icon: 'error',
                customClass: {
                  confirmButton: 'btn btn-primary',
                },
                buttonsStyling: false,
              })
            }
            
          }).catch(err=>{
            console.log(err);
          })

          
        } else if (result.dismiss === 'cancel') {
          this.$swal({
            title: 'Cancelado',
            text: 'El registro esta a salvo :)',
            icon: 'error',
            customClass: {
              confirmButton: 'btn btn-success',
            },
          })
        }
      })
    }
  },
  mounted(){
    let userData = JSON.parse(localStorage.userData)
    if(userData.permissions.find( permission => permission.name === 'edit_projects')){
      this.boolEdit=true
    }

    if(userData.permissions.find( permission => permission.name === 'delete_projects')){
      this.boolDelete=true
    }
  }
}
</script>

<style lang="scss">
</style>
